# Public domain; distribute freely.  See README.txt for instructions.
# Last update 2011-03-02, Dave Lindbergh.  Public domain; distribute freely.

From = "FROM ME <username@gmail.com>"       # note that Gmail ignores address inside <>, uses username always
To = "TO WHOEVER <whoever@example.com>"     # put the destination email address here (where you want messages to go)
Server = 'smtp.gmail.com'                   # the FQDN of your SMTP server goes here (example is setup for Gmail)
User = 'username@gmail.com'                 # your SMTP server username goes here (usually the same as your email address)
Pass = 'passwordGoesHere'                   # your password to your SMTP server goes here
    
def smtpsend(server, username, password, fromAddr, toAddrs, subject, body):
    '''low-level email sender.  Returns result from SMTP.sendmail()'''
    
    import smtplib

    if type(toAddrs) is str:
        toAddrs = [ toAddrs ]       # force a list if necessary
        
    s = smtplib.SMTP(server, 587)
    s.starttls()                    # secure connection
    s.ehlo()                        # not sure if this is needed; seems to work without it
    s.login(username, password)

    message = """\
From: %s
To: %s
Subject: %s

%s
""" % (fromAddr, ", ".join(toAddrs), subject, body)

    s.sendmail(fromAddr, toAddrs, message)
    s.quit()
    
def checkRAID():
    '''
    Checks RAID array status on current machine.  Sends email with result.
    Returns number of bytes in grep.out logfile with errors (if nonzero).
    '''
    
    import os
    
    os.system('del dumpevt.out')                                # cleanup from last time (if exited with ^C)
    
    os.system('dumpevt /logfile=sys /outfile=dumpevt.out')      # dump system log additions since last run to dumpevt.out
    os.system('grep ,LDM, dumpevt.out > grep.out')              # extract lines with ",LDM," (Windows Software RAID messages)
    os.system('grep ,nvrd dumpevt.out >> grep.out')             # extract lines with ",nvrd" (NVidia MediaStorage RAID messages)

    bytes = os.stat('grep.out').st_size

    if bytes == 0:
        subject = os.getenv('COMPUTERNAME')+" RAID is OK"
        log = ""
    else:
        subject = "RAID on " + os.getenv('COMPUTERNAME')+ " has messages!!! (see body)" 
   
        f = open("grep.out")
        log = f.read()
        f.close()
    
    smtpsend(Server, User, Pass, From, To, subject, log)
    
    return bytes

if __name__ == "__main__":
    checkRAID()
